"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.renderHook = renderHook;
exports.testHook = testHook;
Object.defineProperty(exports, "cleanup", {
  enumerable: true,
  get: function get() {
    return _reactTestingLibrary.cleanup;
  }
});
Object.defineProperty(exports, "act", {
  enumerable: true,
  get: function get() {
    return _reactTestingLibrary.act;
  }
});

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _reactTestingLibrary = require("react-testing-library");

function TestHook(_ref) {
  var callback = _ref.callback,
      hookProps = _ref.hookProps,
      children = _ref.children;
  children(callback(hookProps));
  return null;
}

function renderHook(callback, _ref2) {
  if (_ref2 === void 0) {
    _ref2 = {};
  }

  var _ref3 = _ref2,
      initialProps = _ref3.initialProps,
      options = (0, _objectWithoutPropertiesLoose2.default)(_ref3, ["initialProps"]);
  var result = {
    current: null
  };
  var hookProps = {
    current: initialProps
  };
  var resolvers = [];

  var waitForNextUpdate = function waitForNextUpdate() {
    return new Promise(function (resolve) {
      resolvers.push(resolve);
    });
  };

  var toRender = function toRender() {
    return _react.default.createElement(TestHook, {
      callback: callback,
      hookProps: hookProps.current
    }, function (res) {
      result.current = res;
      resolvers.splice(0, resolvers.length).forEach(function (resolve) {
        return resolve();
      });
    });
  };

  var _render = (0, _reactTestingLibrary.render)(toRender(), options),
      unmount = _render.unmount,
      rerenderComponent = _render.rerender;

  return {
    result: result,
    waitForNextUpdate: waitForNextUpdate,
    unmount: unmount,
    rerender: function rerender(newProps) {
      if (newProps === void 0) {
        newProps = hookProps.current;
      }

      hookProps.current = newProps;
      rerenderComponent(toRender());
    }
  };
}

function testHook() {
  console.warn('`testHook` has been deprecated and will be removed in a future release.  Please use `renderHook` instead.');
  return renderHook.apply(void 0, arguments);
}